
% suppose qu'on connaît l'identification des features
ids = visible;

% Calcul des matrices Jacobiennes
F = [eye(3) zeros(3,3*N)];  % Matrice de transition d'état
g = [0, 0, -u(1)/u(2)*cos(X(3)) + u(1)/u(2)*cos(X(3)+u(2)*dt); ...
     0, 0, -u(1)/u(2)*sin(X(3)) + u(1)/u(2)*sin(X(3)+u(2)*dt); ...
     0, 0,  0  ];
 
% Propagation
X = X + F'*[-u(1)/u(2)*sin(X(3)) + u(1)/u(2)*sin(X(3)+u(2)*dt); ...
             u(1)/u(2)*cos(X(3)) - u(1)/u(2)*cos(X(3)+u(2)*dt); ...
             u(2)*dt ];

% Affichage des mesures dans le repere local
%for indexZ = 1:size(ranges,2)
%   plot(ranges(indexZ)*cos(angles(indexZ)+X(3))+X(1),ranges(indexZ)*sin(angles(indexZ)+X(3))+X(2),'go');
%end
         
         
G = eye(3*N+3) + F'*g*F;
P = G*P*G' + F'*R*F;

for i = 1:numel(visible)
    s = visible(i);
    if isempty(find(seen == s))
        % Jamais observe
        display(sprintf('Nouveau landmark %d',s));
        X(3*s+1) = X(1) + ranges(i)*cos(angles(i)+X(3));
        X(3*s+2) = X(2) + ranges(i)*sin(angles(i)+X(3));
        X(3*s+3) = s;
        seen = [seen s];
    end
    
    dx = X(3*s+1)-X(1);
    dy = X(3*s+2)-X(2);
    delta = [dx; dy];
    q = delta'*delta;
    
    z = [ranges(i); angles(i); s];
    zhat = [sqrt(q); atan2(dy,dx)-X(3); X(3*s+3)];
    
    Fj = [F; [zeros(3,3*s) eye(3) zeros(3,3*N-3*s)]];
    
    h = [-sqrt(q)*dx, -sqrt(q)*dy, 0, sqrt(q)*dx, sqrt(q)*dy, 0; ...
             dy,           -dx,   -q,    -dy,         dx,     0; ...
              0,            0,     0,      0,          0,     q];
    H = h*Fj;
    H = H./q;
    
    Denom = (H*P*H'+Q);
    %display(sprintf('det(Denom)=%.6f',det(Denom)));
    
    K = P*H'/Denom;
    %K = P*H'*pinv(Denom);
    zError = (z-zhat);
    % Il faut s'assurer que l'erreur reste entre pi et -pi
    zError(2) = wrapToPi(zError(2));
    
    X = X + K*zError;
    P = (eye(3*N+3)-K*H)*P;
    %display(sprintf('det(P)=%.6f',det(P)));
    %display(sprintf('cond(P)=%.6f',cond(P)));
    X(1:3);
end

%figure(1)





